unit Common;
interface
uses
   Objects;

type
   TVideoMem =     Array [0..199, 0..319] of Byte;

var
   VM              :TVideoMem absolute $A000:0;

var
   BackPtr,
   BufferPtr,
   FireBuffer,
   FinalBuffer     :^TVideoMem;

const
   UseTV           :Boolean= True;

const
   Timer           :Word =   0;
   StartTimer =    75;
var
   LTimer          :Word;

procedure UpdateScreen;

implementation
uses
   General, MousePtr,
   GraphFns, Scale{,
   Gfx1};
{
procedure UpdateScreen1;
const
   PX =            107;
   SX =            86;
   PY =            67;
   SY =            58;
   FirstPass       :Boolean= True;
var
   Save            :Pointer;
   Y, XS, XT       :Word;
begin
   if FirstPass then
   begin
      Save:=BufferPtr; BufferPtr:=@VM;
      PutBlock(80, 50, @_TV);
      BufferPtr:=Save;
      FirstPass:=False;
   end;

   for Y:=0 to SY-1 do
   begin
      if Y<=2 then XS:=(320 div 4)*(Y+1) else
      if Y>=SY-3 then XS:=(320 div 4)*(SY-Y) else XS:=320;
      XT:=LongDiv(LongMul(XS, SX), 320);

      Scale.InitScale(XS, XT);
      Scale.ScaleLine(
         PChar(FinalBuffer)+(320-XS)+320*Word(LongDiv(LongMul(Y, 200), SY)),
         PChar(@VM)+(SX-XT)+(Y+PY)*320+PX);
   end;
end;
}
procedure UpdateScreen{2};
const
   BlkCnt =        8;
var
   Blk, Y          :Integer;
begin
   Y:=0;
   for Blk:=0 to BlkCnt-1 do
   begin
      Inc(MouseLock);
      DoShowMouse(FinalBuffer, @MouseBack);
      Move(FinalBuffer^[Y], VM[Y], 320*200 div BlkCnt);
      DoHideMouse(FinalBuffer, @MouseBack);
      Dec(MouseLock);
      if MouseMoveCnt>0 then
      begin
         Dec(MouseMoveCnt);
         MoveMouse;
      end;
      Inc(Y, 200 div BlkCnt);
   end;
end;
{
procedure UpdateScreen;
begin
   if UseTV then UpdateScreen1 else UpdateScreen2;
end;
}
end.
